package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type UpdateSecurityGroupLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewUpdateSecurityGroupLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdateSecurityGroupLogic {
	return &UpdateSecurityGroupLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UpdateSecurityGroupLogic) UpdateSecurityGroup(req *types.UpdateSecurityGroupReq) (resp *types.UpdateSecurityGroupResp, err error) {
	// todo: add your logic here and delete this line
	UpdateSecurityGroupReq := &openstack.UpdateSecurityGroupReq{}
	err = copier.CopyWithOption(UpdateSecurityGroupReq, req, copier.Option{Converters: utils.Converters})
	UpdateSecurityGroupResp, err := l.svcCtx.OpenstackRpc.UpdateSecurityGroup(l.ctx, UpdateSecurityGroupReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&UpdateSecurityGroupResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &UpdateSecurityGroupResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
